﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
#Event: NewData (Buffer() As Byte)
#Event: Terminated

Sub Class_Globals
'	Private fx As JFX
	Private mTarget As Object
	Private mEventName As String
	Private astreams As AsyncStreams
	Private mLength As Int

	Private TimerPort As Timer
	Private lengthReceive, ticksPort As Int = 0
	Private bb As B4XBytesBuilder
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (TargetModule As Object, In As InputStream, out As OutputStream, bufLength As Int, EventName As String)
	mTarget = TargetModule
	mEventName = EventName
	mLength = bufLength
	astreams.Initialize(In, out, "astreams")

	TimerPort.Initialize("TimerPort", 25)
	TimerPort.Enabled = True
	bb.Initialize
	
End Sub

Public Sub Write(wBuffer() As Byte)
	astreams.Write(wBuffer)
End Sub

Private Sub astreams_NewData (Buffer() As Byte)
	lengthReceive = Buffer.Length
	ticksPort = 0
	'Private s As String = PrintHexInfo(Buffer)
	
	'LogMessage("You " & Buffer.Length, s)
	
	bb.Append(Buffer)
	Private outputBuffer() As Byte = bb.ToArray
	If outputBuffer.Length >=mLength Then
		CallSubDelayed2(mTarget, mEventName & "_NewData", outputBuffer)
		ticksPort = 0
		lengthReceive = 0
		bb.Clear
	End If
End Sub

Sub TimerPort_Tick
	If lengthReceive > 0 Then
		ticksPort = ticksPort +1
		If ticksPort >3 Then
			Private outputBuffer() As Byte = bb.ToArray
			'LogMessage("OUT " & outputBuffer.Length, PrintHexInfo(outputBuffer))
			CallSubDelayed2(mTarget, mEventName & "_NewData", outputBuffer)
			
			ticksPort = 0
			lengthReceive = 0
			bb.Clear
		End If
	End If
End Sub

Private Sub astreams_Terminated
	CallSubDelayed(mTarget, mEventName & "_Terminated")
End Sub

Private Sub astreams_Error
	'Log("error: " & LastException)
	astreams.Close
	CallSubDelayed(mTarget, mEventName & "_Terminated")
End Sub

Public Sub Close
	astreams.Close
	TimerPort.Enabled = False
	
End Sub

